open Cpcore

let inNat n = either (const 0) succ n

let outNat num = match num with
    | 0 -> i1 ()
    | n when n>0 -> i2 (n-1)
    | _ -> invalid_arg "outNat: negative integer not supported"

(* (2) Ana + cata + hylo ----------------------------------------------- *)

let recNat f n = (id -|- f) n

let rec cataNat g n = (g <. recNat (cataNat g) <. outNat) n

let rec anaNat  g n = (inNat <. recNat (anaNat g) <. g) n

let hyloNat f g n = (cataNat f <. anaNat g) n 

let forNat b i = cataNat (either (const i) b)

let fib = p2 <. (forNat (split add p1) (1,1))
